Summary: The VIM editor.
Name: vim
Version: 5.7
%define vimversion vim57
Release: 1.3.0
Copyright: freeware
Group: Applications/Editors
Source0: ftp://ftp.home.vim.org/pub/vim/unix/vim-%{version}-src.tar.gz
Source1: ftp://ftp.home.vim.org/pub/vim/unix/vim-%{version}-rt.tar.gz
Source3: vimrc
Patch0: vim-4.2-speed_t.patch
Patch1: vim-5.1-vimnotvi.patch
Patch2: vim-5.6a-paths.patch
Patch3: vim-5.6-fixkeys.patch
Patch4: vim-5.6-specsyntax.patch
Patch5: vim-5.6-destdir.patch
Patch6: vim-5.7-redhat.patch
Patch7: vim-5.7-docpath.patch
Patch8: vim-5.7-crv.patch
Patch9: vim-5.7-security.patch
Patch10: vim-5.7-5.x.patch

Patch101: 5.7.001
Patch102: 5.7.002
Patch103: 5.7.003
Patch104: 5.7.004
Patch105: 5.7.005
Patch106: 5.7.006
Patch107: 5.7.007
Patch108: 5.7.008
Patch112: 5.7.012
Patch113: 5.7.013
Patch114: 5.7.014
Patch115: 5.7.015
Patch116: 5.7.016
Patch117: 5.7.017
Patch118: 5.7.018
Patch119: 5.7.019
Patch120: 5.7.020
Patch121: 5.7.021
Patch122: 5.7.022
Patch123: 5.7.023
Patch124: 5.7.024
Buildroot: /var/tmp/vim-root
Buildrequires: perl

%description
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.

%package common
Summary: The common files needed by any version of the VIM editor.
Group: Applications/Editors

%description common
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.  The
vim-common package contains files which every VIM binary will need in
order to run.

If you are installing any version of the VIM editor, you'll also need
to the vim-common package installed.

%package minimal
Summary: A minimal version of the VIM editor.
Group: Applications/Editors
# Requires: vim-common
Obsoletes:  vim

%description minimal
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more. The
vim-minimal package includes a minimal version of VIM, which is
installed into /bin/vi for use when only the root partition is
present.

%package enhanced
Summary: A version of the VIM editor which includes recent enhancements.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-color

%description enhanced
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and more.  The
vim-enhanced package contains a version of VIM with extra, recently
introduced features like Python and Perl interpreters.

Install the vim-enhanced package if you'd like to use a version of the
VIM editor which includes recently added enhancements like
interpreters for the Python and Perl scripting languages.  You'll also
need to install the vim-common package.

%package X11
Summary: The VIM version of the vi editor for the X Window System.
Group: Applications/Editors
Requires: vim-common

%description X11
VIM (VIsual editor iMproved) is an updated and improved version of the
vi editor.  Vi was the first real screen-based editor for UNIX, and is
still very popular.  VIM improves on vi by adding new features:
multiple windows, multi-level undo, block highlighting and
more. VIM-X11 is a version of the VIM editor which will run within the
X Window System.  If you install this package, you can run VIM as an X
application with a full GUI interface and mouse support.

Install the vim-X11 package if you'd like to try out a version of vi
with graphics and mouse capabilities.  You'll also need to install the
vim-common package.

%prep
%setup -q -b 1
%patch0 -p1 -b .4.2
%patch1 -p1 -b .vim
# fix rogue dependencies from sample code
chmod -x runtime/tools/mve.awk
%patch2 -p1 -b .paths
find . -name \*.paths | xargs rm -f
%patch3 -p1 -b .fixkeys
%patch4 -p1 -b .highlite
%patch5 -p1 -b .destdir
%patch6 -p1 -b .redhat
%patch7 -p1 -b .docs
%patch8 -p1 -b .crv

%patch101 -p0 -b .p1
%patch102 -p0 -b .p2
%patch103 -p0 -b .p3
%patch104 -p0 -b .p4
%patch105 -p0 -b .p5
%patch106 -p0 -b .p6
%patch107 -p0 -b .p7
%patch108 -p0 -b .p8
%patch112 -p0 -b .p12
%patch113 -p0 -b .p13
%patch114 -p0 -b .p14
%patch115 -p0 -b .p15
%patch116 -p0 -b .p16
%patch117 -p0 -b .p17
%patch118 -p0 -b .p18
%patch119 -p0 -b .p19
%patch120 -p0 -b .p20
%patch121 -p0 -b .p21
%patch122 -p0 -b .p22
%patch123 -p0 -b .p23
%patch124 -p0 -b .p24


perl -pi -e "s,bin/nawk,bin/awk,g" runtime/tools/mve.awk

%build
cd src
perl -pi -e "s,\\\$VIMRUNTIME,/usr/share/vim/%{vimversion},g" os_unix.h
perl -pi -e "s,\\\$VIM,/usr/share/vim/%{vimversion}/macros,g" os_unix.h

%configure --enable-max-features=yes --disable-pythoninterp --enable-perlinterp --disable-tclinterp --with-x=yes --exec-prefix=/usr
make if_perl.c
perl -pi -e "s,#define.*PL_na.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_defgv.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_errgv.*,,g" if_perl.c
make 
cp vim gvim
make clean

%configure --prefix=/usr --enable-max-features=yes --disable-pythoninterp \
 --enable-perlinterp --disable-tclinterp --with-x=no --enable-gui=no \
 --exec-prefix=/usr
make if_perl.c
perl -pi -e "s,#define.*PL_na.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_defgv.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_errgv.*,,g" if_perl.c
make
cp vim enhanced-vim
make clean

%configure --prefix='${DEST}'/usr --enable-min-features=yes --with-x=no \
  --disable-pythoninterp --disable-perlinterp --disable-tclinterp \
  --with-tlib=termcap --enable-gui=no --disable-gpm --exec-prefix=/
make if_perl.c
perl -pi -e "s,#define.*PL_na.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_defgv.*,,g" if_perl.c
perl -pi -e "s,#define.*PL_errgv.*,,g" if_perl.c
make


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/usr/{bin,share/vim,X11R6/bin}

cd src
%makeinstall BINDIR=$RPM_BUILD_ROOT/bin DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT/bin/xxd $RPM_BUILD_ROOT/usr/bin
make installmacros DESTDIR=$RPM_BUILD_ROOT
install -s -m755 gvim $RPM_BUILD_ROOT/usr/X11R6/bin
install -s -m755 enhanced-vim $RPM_BUILD_ROOT/usr/bin/vim

( cd $RPM_BUILD_ROOT
  mv ./bin/vim ./bin/vi
  mv ./bin/vimtutor ./usr/bin
  rm -f ./bin/rvim
  ln -sf vi ./bin/view
  ln -sf vi ./bin/ex
  ln -sf vi ./bin/rvi
  ln -sf vi ./bin/rview
  ln -sf vim ./usr/bin/ex
  perl -pi -e "s,$RPM_BUILD_ROOT,," .%{_mandir}/man1/vim.1 .%{_mandir}/man1/vimtutor.1
  rm -f .%{_mandir}/man1/rvim.1
  ln -sf vim.1.gz .%{_mandir}/man1/vi.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/rvi.1.gz
  ln -sf vim.1.gz .%{_mandir}/man1/gvim.1.gz
  ln -sf gvim ./usr/X11R6/bin/vimx
  mkdir -p ./etc/X11/applnk/Utilities
  cat > ./etc/X11/applnk/Utilities/gvim.desktop <<EOF
[Desktop Entry]
Name=gvim
Type=Application
Comment=VI editor for X Windows
Exec=gvim
EOF
  install -s -m644 %{SOURCE3} ./usr/share/vim/%{vimversion}/macros/
  ln -s vimrc ./usr/share/vim/%{vimversion}/macros/gvimrc
)

# Dependency cleanups
chmod 644 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/doc/vim2html.pl \
 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/tools/*.pl \
 $RPM_BUILD_ROOT/usr/share/vim/%{vimversion}/tools/vim132
chmod 644 ../runtime/doc/vim2html.pl

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(-,root,root)
%doc README*.txt runtime/macros/README.txt runtime/tools/README.txt
%doc runtime/doc runtime/syntax runtime/termcap runtime/tutor
%doc runtime/*.vim
/usr/bin/vimtutor
# /usr/bin/xxd

/usr/share/vim
%{_mandir}/man1/vim.*
%{_mandir}/man1/vimtutor.*
%{_mandir}/man1/ex.*
%{_mandir}/man1/vi.*
%{_mandir}/man1/view.*
%{_mandir}/man1/rvi.*
%{_mandir}/man1/rview.*
%{_mandir}/man1/xxd.*

%files minimal
%defattr(-,root,root)
/bin/ex
/bin/vi
/bin/view
/bin/rvi
/bin/rview

%files enhanced
%defattr(-,root,root)
/usr/bin/vim
/usr/bin/ex

%files X11
%defattr(-,root,root)
%config(missingok) /etc/X11/applnk/Utilities/gvim.desktop
/usr/X11R6/bin/gvim
/usr/X11R6/bin/vimx
%{_mandir}/man1/gvim.*

%changelog
* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Mon Feb 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Mon Feb 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.2.0
  - Initial build for EnGarde v1.2 (Parry).
  - Removed pre-EnGarde changelog.

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.7, Release 1.1.0
  - Initial build for EnGarde v1.1 (Balestra).

* Thu Mar 29 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.7, Release 1.0.2
  - Applied various security patches and updates.

* Wed Oct 09 2000 Pete O'Hara <pete@guardiandigital.com>
- basic version from RH7
